LDCONFIG(8) | System Manager's Manual | LDCONFIG(8)

# NAME

`ldconfig` —
configure the a.out shared library cache

# SYNOPSIS

`ldconfig` | [`-cmrsSv`] [directory ...]

# DESCRIPTION

`ldconfig` is used to prepare a set of “hints” for use by the a.out run-time linker `ld.so` to facilitate quick lookup of shared libraries available in multiple directories. `ldconfig` is only available on systems that use the “a.out” format for executables and libraries – on ELF systems, all the work is done by `ld.elf_so`.

By default, it scans a set of built-in system directories, directories listed in /etc/ld.so.conf, and any directories specified on the command line (in the given order) looking for shared libraries and stores the results in the file /var/run/ld.so.hints to forestall the overhead that would otherwise result from the directory search operations `ld.so` would have to perform to load required shared libraries.

The shared libraries so found will be automatically available for loading if needed by the program being prepared for execution. This obviates the need for storing search paths within the executable.

The `LD_LIBRARY_PATH` environment variable can be used to override the use of directories (or the order thereof) from the cache or to specify additional directories where shared libraries might be found. `LD_LIBRARY_PATH` is a ‘:’ separated list of directory paths that are searched by `ld.so` when it needs to load a shared library. It can be viewed as the run-time equivalent of the `-L` switch of `ld`.

`ldconfig` is typically run as part of the boot sequence.

The following options are recognized by `ldconfig`:

`-c`
  Do not scan directories listed in /etc/ld.so.conf for shared libraries.
`-m`
  Merge the result of the scan of the directories given as arguments into the existing hints file. The default action is to build the hints file afresh.
`-r`
  Lists the current contents of ld.so.hints on the standard output. The hints file will not be modified.
`-s`
  Do not scan the built-in system directory (/usr/lib), nor any directories listed in /etc/ld.so.conf for shared libraries.
`-S`
  Do not scan the built-in system directory (/usr/lib), for shared libraries. (Directories listed in /etc/ld.so.conf are still scanned.)
`-v`
  Switch on verbose mode.

# FILES

/var/run/ld.so.hints, /etc/ld.so.conf

# SEE ALSO

ld(1), ld.so(1), ld.so.conf(5), link(5)

# HISTORY

A `ldconfig` utility first appeared in SunOS 4.0, it appeared in its current form in NetBSD 0.9A.

# SECURITY CONSIDERATIONS

Special care must be taken when loading shared libraries into the address space of set-user-ID programs. Whenever such a program is run, `ld.so` will only load shared libraries from the ld.so.hints file. In particular, the `LD_LIBRARY_PATH` and `LD_PRELOAD` is not used to search for libraries. Thus, the role of ldconfig is dual. In addition to building a set of hints for quick lookup, it also serves to specify the trusted collection of directories from which shared objects can be safely loaded. It is presumed that the set of directories specified to `ldconfig` is under control of the system's administrator. `ld.so` further assists set-user-ID programs by erasing the `LD_LIBRARY_PATH` and `LD_PRELOAD` from the environment.

October 8, 2000 | NetBSD 10.1